CSIT-806 Container Orchestration in CSIT - Low Level Design
[csit.git] / bootstrap-verify-perf-ligato.sh
index 7c4c6d3..10470dc 100644 (file)
@@ -29,10 +29,65 @@ PYBOT_ARGS="-W 150 -L TRACE"
 
 ARCHIVE_ARTIFACTS=(log.html output.xml report.html output_perf_data.xml)
 
+# If we run this script from CSIT jobs we want to use stable vpp version
+if [[ ${JOB_NAME} == csit-* ]] ;
+then
+    mkdir -p vpp/build-root
+    cd vpp/build-root
+
+    if [[ ${TEST_TAG} == *NIGHTLY ]] || \
+       [[ ${TEST_TAG} == *DAILY ]] || \
+       [[ ${TEST_TAG} == *WEEKLY ]];
+    then
+        # Download the latest VPP build .deb install packages
+        echo Downloading VPP packages...
+        bash ${SCRIPT_DIR}/resources/tools/scripts/download_install_vpp_pkgs.sh --skip-install
+
+        VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
+        # Take vpp package and get the vpp version
+        VPP_STABLE_VER="$( expr match $(ls *.deb | head -n 1) 'vpp-\(.*\)-deb.deb' )"
+    else
+        DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER)_amd64
+        VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_UBUNTU)
+        VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_UBUNTU)
+        VPP_CLASSIFIER="-deb"
+        # Download vpp build from nexus and set VPP_DEBS variable
+        wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        # Temporary disable using dpdk
+        # wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${DPDK_STABLE_VER}/vpp-dpdk-dkms-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        wget -q "${VPP_REPO_URL}/vpp-plugins/${VPP_STABLE_VER}/vpp-plugins-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
+        VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
+    fi
+
+    # Temporary workaround as ligato docker file requires specific file name
+    rename -v 's/^(.*)-(\d.*)-deb.deb/$1_$2.deb/' *.deb
+    cd ${SCRIPT_DIR}
+
+# If we run this script from vpp project we want to use local build
+elif [[ ${JOB_NAME} == vpp-* ]] ;
+then
+    mkdir -p vpp/build-root
+    # Use local packages provided as argument list
+    # Jenkins VPP deb paths (convert to full path)
+    VPP_DEBS="$( readlink -f $@ | tr '\n' ' ' )"
+    # Take vpp package and get the vpp version
+    VPP_STABLE_VER="$( expr match $1 'vpp-\(.*\)-deb.deb' )"
+    # Move files to build-root for packing
+    for deb in ${VPP_DEBS}; do mv ${deb} vpp/build-root/; done
+else
+    echo "Unable to identify job type based on JOB_NAME variable: ${JOB_NAME}"
+    exit 1
+fi
+
+# Compress all VPP debs and remove temporary directory
+tar -zcvf ${SCRIPT_DIR}/vpp.tar.gz vpp/*  && rm -R vpp
+
 LIGATO_REPO_URL=$(cat ${SCRIPT_DIR}/LIGATO_REPO_URL)
-LIGATO_STABLE_VER=$(cat ${SCRIPT_DIR}/LIGATO_STABLE_VER)
-VPP_COMMIT=$1
-VPP_BUILD=$1
+VPP_AGENT_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_AGENT_STABLE_VER)
+VPP_AGENT_STABLE_COMMIT="$( expr match `cat VPP_AGENT_STABLE_VER` '.*g\(.*\)' )"
 DOCKER_DEB="docker-ce_17.06.2~ce-0~ubuntu_amd64.deb"
 
 # Clone & checkout stable vnf-agent
@@ -42,10 +97,10 @@ if [ $? != 0 ]; then
     echo "Failed to run: git clone --depth 1 ${LIGATO_REPO_URL}/vpp-agent"
     exit 1
 fi
-cd vpp-agent && git checkout ${LIGATO_STABLE_VER}
+cd vpp-agent && git checkout ${VPP_AGENT_STABLE_COMMIT}
 # If the git checkout fails, complain clearly and exit
 if [ $? != 0 ]; then
-    echo "Failed to run: git checkout ${LIGATO_STABLE_VER}"
+    echo "Failed to run: git checkout ${VPP_AGENT_STABLE_VER}"
     exit 1
 fi
 
@@ -58,12 +113,17 @@ if [ $? != 0 ]; then
     exit 1
 fi
 
-# Compile vnf-agent docker image
-cd ${SCRIPT_DIR}/../vpp-agent/docker/dev_vpp_agent/ &&\
-    ./build.sh --agent ${LIGATO_STABLE_VER} --vpp ${VPP_COMMIT} &&\
-    ./shrink.sh
+# Pull ligato/dev_vpp_agent docker image and re-tag as local
+sudo docker pull ligato/dev-vpp-agent:${VPP_AGENT_STABLE_VER}
+sudo docker tag ligato/dev-vpp-agent:${VPP_AGENT_STABLE_VER}\
+    dev_vpp_agent:latest
+sudo docker images
+
+# Build prod_vpp_agent docker image
 cd ${SCRIPT_DIR}/../vpp-agent/docker/prod_vpp_agent/ &&\
-    ./build.sh &&\
+    mv ${SCRIPT_DIR}/vpp.tar.gz . &&\
+    ./extract_agent_files.sh &&\
+    sudo docker build -t prod_vpp_agent --no-cache . &&\
     ./shrink.sh
 # Export Docker image
 sudo docker save prod_vpp_agent_shrink | gzip > prod_vpp_agent_shrink.tar.gz
@@ -135,7 +195,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include ndrdiscANDnic_intel-x520-da2AND1t1cORndrdiscANDnic_intel-x520-da2AND2t2c \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -144,7 +204,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include ndrdiscANDnic_intel-x710AND1t1cORndrdiscANDnic_intel-x710AND2t2cORndrdiscANDnic_intel-xl710AND1t1cORndrdiscANDnic_intel-xl710AND2t2c \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -153,7 +213,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include ndrdiscAND1t1cORndrdiscAND2t2c \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -162,7 +222,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include pdrdiscAND1t1cORpdrdiscAND2t2c \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -171,7 +231,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include ndrchkAND1t1cORndrchkAND2t2c \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -180,7 +240,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include ndrchkAND1t1cORndrchkAND2t2c \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -189,7 +249,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip4baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -198,7 +258,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip6baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -207,7 +267,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDl2xcbaseORndrdiscANDnic_intel-x520-da2AND1t1cANDl2bdbase \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -216,7 +276,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDlisp \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -225,7 +285,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvxlan \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -234,7 +294,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -243,7 +303,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include pdrchkANDnic_intel-x520-da2AND1t1cANDip4baseORpdrchkANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -252,7 +312,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include pdrchkANDnic_intel-x520-da2AND1t1cANDip6baseORpdrchkANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -261,7 +321,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include pdrchkANDnic_intel-x520-da2AND1t1cANDl2xcbaseORpdrchkANDnic_intel-x520-da2AND1t1cANDl2bdbase \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -270,7 +330,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include pdrchkANDnic_intel-x520-da2AND1t1cANDlisp \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -279,7 +339,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include pdrchkANDnic_intel-x520-da2AND1t1cANDvxlan \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -288,7 +348,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -297,7 +357,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDacl \
               --include pdrdiscANDnic_intel-x520-da2AND2t2cANDacl \
               tests/
@@ -307,7 +367,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               --exclude SKIP_PATCH \
               -i NDRPDRDISC \
               tests/
@@ -317,7 +377,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               -i NDRCHK \
               tests/
         RETURN_STATUS=$(echo $?)
@@ -327,7 +387,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               tests/
         RETURN_STATUS=$(echo $?)
         ;;
@@ -336,7 +396,7 @@ case "$TEST_TAG" in
         pybot ${PYBOT_ARGS} \
               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
               -v DPDK_TEST:True \
-              -s "tests.ligato.perf" \
+              -s "tests.kubernetes.perf" \
               tests/
         RETURN_STATUS=$(echo $?)
 esac
@@ -347,7 +407,7 @@ echo Post-processing test data...
 python ${SCRIPT_DIR}/resources/tools/scripts/robot_output_parser.py \
        -i ${SCRIPT_DIR}/output.xml \
        -o ${SCRIPT_DIR}/output_perf_data.xml \
-       -v ${VPP_BUILD}
+       -v ${VPP_STABLE_VER}
 if [ ! $? -eq 0 ]; then
     echo "Parsing ${SCRIPT_DIR}/output.xml failed"
 fi